#!/usr/bin/perl

sub RequestForm {
  local (*in) = @_ if @_;
  local ($i, $key, $val);

  if (&GetRequest) {
    $in = $ENV{'QUERY_STRING'};
  } elsif (&PostRequest) {
    read(STDIN,$in,$ENV{'CONTENT_LENGTH'});
  }

  @in = split(/[&;]/,$in);

  foreach $i (0 .. $#in) {
    # Xy[X+ɕϊ
    $in[$i] =~ s/\+/ /g;

    ($key, $val) = split(/=/,$in[$i],2); 

    $key =~ s/%(..)/pack("c",hex($1))/ge;
    $val =~ s/%(..)/pack("c",hex($1))/ge;

    $in{$key} .= "\0" if (defined($in{$key})); 
    $in{$key} .= $val;

  }

  return scalar(@in);
}

sub GetRequest {
  return ($ENV{'REQUEST_METHOD'} eq "GET");
}
sub PostRequest {
  return ($ENV{'REQUEST_METHOD'} eq "POST");
}
1;
